<template>
  <div class="sbosidebar">
    <el-dialog
      destroy-on-close
      :before-close="close"
      width="100%"
      custom-class="sidebar-dialog-provider"
      v-model="visible"
      :show-close="false"
    >
      <template #title>
        <div class="w-full text-center" @click="close">
          <font-awesome-icon class="text-[25px]" icon="angle-down" />
        </div>
      </template>
      <div class="flex flex-wrap">
        <div
          v-for="provider in providers"
          :key="provider.ProviderName"
          class="w-[33.33%] text-center"
        >
          <div
            class="text-white"
            @click="
              handleProviderClicked(provider.ProviderName)
            "
          >
            <div class="py-[10px] px-0">
              <div class="mb-[5px] h-[70px]">
                <img
                  class="w-full h-full object-contain object-center align-middle max-w-full"
                  :src="
                    getAssetImage(
                      `assets/theme/black_modern_1/images/gameProviders/${provider.ProviderName.split(
                        ' '
                      ).join('')}.png`
                    )
                  "
                />
              </div>
              <div class="text-center">
                {{ provider.GameProviderDisplayName }}
              </div>
            </div>
          </div>
        </div>
      </div>
    </el-dialog>
  </div>
</template>

<script lang="ts">
import { defineComponent, toRefs } from "vue";
import { useRouter } from "vue-router";
import { useGameEntryComponent } from "@/composables/useTheme";

export default defineComponent({
  props: {
    dialogVisible: {
      type: Boolean,
      required: true,
    },
    handleClick: {
      type: Function,
      required: false,
    },
  },
  emits: ["update:dialogVisible"],
  setup(props, { emit }) {
    const { providers } = useGameEntryComponent();
    const { dialogVisible: visible } = toRefs(props);
    const { getAssetImage } = commonHelper;
    const router = useRouter();
    const close = () => {
      emit("update:dialogVisible", false);
    };
    const handleProviderClicked = (path: string) => {
      emit("update:dialogVisible", false);
      router.push(`/games/${path}`);
      props.handleClick?.();
    };

    return {
      handleProviderClicked,
      getAssetImage,
      close,
      visible,
      providers,
    };
  },
});
</script>
<style lang="scss">
.sidebar-dialog-provider.el-dialog {
  max-height: 428.56px;
  background: #082a5c;
  position: absolute;
  bottom: 0;
  .el-dialog__body {
    padding-top: 0;
    overflow: scroll;
    height: 370px;
  }
}
</style>
